import easygui
import os
import sys
import itertools
from static_files.dict_elmtypes import num_nodes_dict
from static_files.dict_elmtypes import expand_dict

 ##################################################################################
 ##
 ## FUNCTIONS:
 ##
 ##################################################################################




def read_inp_input(inp_path):

    lines_in=open(inp_path).readlines()
    # print(lines_in)
    if (lines_in[-1][-1:]) == '\n':
        print('\n*** WARNING! BLANK LINE AT THE END OF FILE !!!\n')
        return
    #
    linewise_incl=[]
    count= 1
    #print(lines_in[:-1])
    for line in lines_in:

        if line == lines_in[-1]:
            linewise_incl.append([line])
        else:
            linewise_incl.append([line[:-1]])
            
        if len(line[0:-1]) < 1 or len(line) < 2:
            print('*** WARNING! : BLANK LINE @ LINE NUMBER ' + str(count))
            
            
        count += 1   
    linewise_incl.append(['*FINISH'])
    return(linewise_incl)




def inp_to_dicos(linewise_incl):
    elm_lst = []
    node_lst = []
    elm_lst_col = []
    elm_lst_int = []
    sys_lst=[]
    
    j = 0
    i = 0
    
    elm_count = 0
    # 
    while i < (len(linewise_incl)-1):
        #print(linewise_incl[i])

        if len(linewise_incl[i][0]) > 0 and linewise_incl[i][0].split()[0][0:7].lower()=='*system':

            i+=1
            while len(linewise_incl[i][0]) > 1 and ((linewise_incl[i][0].split())[0][0]) !=  '*' or (
                  len(linewise_incl[i][0])) >= 2 and ((linewise_incl[i][0].split())[0][1]) == '*':

                if linewise_incl[i][0].replace(' ','').split(',')[0][0] != '*':
                    sys_lst.append(linewise_incl[i][0].replace(' ','').split(','))
                else:
                    sys_lst.append('/')
                     
                i+=1

            sys_lst_tmp=[]
            for s in range(0,len(sys_lst)):
                
                sys_lst_tmp += sys_lst[s]

            #print('Gefundene Systeme:', sys_lst)
        
            #print('Gefundene Systeme:', sys_lst_tmp)
            #print()
            sys_final=[]
            while sys_lst_tmp:
                first=sys_lst_tmp[:sys_lst_tmp.index('/')]

                rest=sys_lst_tmp[sys_lst_tmp.index('/')+1:]

                sys_final.append(first)

                sys_lst_tmp=rest

            #print(sys_final)
            for s in sys_final:

                sys_final[sys_final.index(s)]=[float(x) for x in s]
                if len(s)==0:
                    sys_final[sys_final.index(s)]=[0.0,0.0,0.0,1.0,0.0,0.0,0.0,1.0,0.0]


            print('Gefundene Koordinatensysteme:', sys_final)
            print()
             
    # check for keyword *NODE
    # append to list node_list
    # for each entry below *NODE (**COMMENTS included)
    # with the loops below, the input file is filtered for keywords
    # all entries following a keyword are gathered in lists till the next keyword (*...) pops up
    # to ensure the input having a defined end, at the top the entry '*FINISH' is appended to list 'linewise_incl'
    #  
    # NODE:
    # 
    # LIST node_lst:
    # node ID, x, y, z
    #  [['133', '2.2332492', '2.2332492', '0.'], ['136', '2.3709724', '2.041033', '0.']...]   
        elif len(linewise_incl[i][0]) > 0 and linewise_incl[i][0].split()[0][0:5].lower()=='*node':
            
            i += 1
         
            
            while len(linewise_incl[i][0]) > 1 and ((linewise_incl[i][0].split())[0][0]) !=  '*' or (
                  len(linewise_incl[i][0])) >= 2 and ((linewise_incl[i][0].split())[0][1]) == '*':
            
                if linewise_incl[i][0].replace(' ','').split(',')[0][0] != '*':
                    node_lst.append(linewise_incl[i][0].replace(' ','').split(','))
                #else:
                #   node_list.append()
                
                i += 1

            #print(node_lst)           
    # 
    # ELEMENTS
    #  
    # LIST elm_lst:
    # elm ID, node 1, node2,..., node i, ELSET, elm TYPE 
    #[['113', '133', '136', '144', '146', 'PSHELL_1', 'S4R'],...]
    #           
        elif len(linewise_incl[i][0]) > 6 and linewise_incl[i][0].split()[0][0:8].lower()=='*element':
            
            elm_lst_col = []
            elm_lst_int = []
                        
            for j in range(len(linewise_incl[i][0].split())):
                         
                # if linewise_incl[i][0].split()[j][0:5].lower() == 'elset':
                    # elset = linewise_incl[i][0].split()[j][6:]
                if linewise_incl[i][0].split()[j][0:4].lower() == 'type':
                    elm_type = (linewise_incl[i][0].split()[j][5:]).replace(',','')
                    try:
                        #a == elm_type in num_nodes_dict.keys()
                        a = num_nodes_dict[elm_type]
                    except KeyError:
                        print('The given element type is not supported:', elm_type)
                        #print('Please add the missing value of nodes per %s element in the dict_elmtypes.py file.' % elm_type)
                        #k=elm_type
                        #v=int(input("Please type in the number of nodes of the unrecognized element type: "))
                        
                        #for i in range(1,4):
                        while True:

                            try:
                                z=int(input("Please type in the number of nodes of the unrecognized element type: "))
                        
                            except ValueError:
                                print('Number of nodes must be an integer!')
                                continue
                            else:
                                break
                            
                        expand_dict(elm_type,z)        
                          
            i += 1
    
            
            while len(linewise_incl[i][0]) > 1 and ((linewise_incl[i][0].split())[0][0]) !=  '*' or (
                len(linewise_incl[i][0])) >= 2 and ((linewise_incl[i][0].split())[0][1]) == '*':
            
                if linewise_incl[i][0].replace(' ','').split(',')[0][0] != '*':
                    

                    elm_lst_col.extend((linewise_incl[i][0].replace(' ','').split(',')) )


                i += 1
                
            #elm_lst_col.remove('')
            #print("elc", elm_lst_col)
#
            for item in elm_lst_col:
                if item != '':
                    elm_lst_int.append(int(item))

            # print('***____***',elm_lst_int)
            #########################################################################################

           
            #num_node_str = ''
            
            #for num in range(3, len(elm_type)):

                #if elm_type[num].isalpha() == False:
                    #num_node_str = num_node_str + elm_type[num]
               
                # num_nodes = int(num_node_str)

            
            num_nodes=num_nodes_dict[elm_type]
            
            
            ##########################################################################################
            #print("NUMBER OF THE NODES :", int(num_node_str), elm_type, elset)
           
            #print(len(elm_lst_int)/(int(num_node_str)+1))
            
            elm_ID_loc = 0
            while elm_ID_loc < len(elm_lst_int):
                elm_temp = [elm_lst_int[elm_ID_loc]]
                #print(elm_ID_loc, elm_temp,num_nodes)
                
                for nodes in range(1,num_nodes+1):
                    elm_temp.append(elm_lst_int[elm_ID_loc + nodes])
                # elm_temp.append(elset)
                
                elm_lst.append(elm_temp)
                
                elm_ID_loc += num_nodes+1
            
            # print("**************ELM_LIST     :", elm_lst)
                
                
                
                    
        else:
            i += 1
                


    # CREATE DICTIONARY FROM NODES:
    nodes_dico = {}
    node_elm_dico = {}
    #
    for node in node_lst:
        
        node_tmp = {int(node[0]):[ float(node[1]), float(node[2]), float(node[3])]}
        

        #node_tmp[int(node[0])]=[tuple(node_tmp[int(node[0])])]

        nodes_dico.update(node_tmp)
        node_elm_dico.update({int(node[0]):[]})
        


    # CREATE DICTIONARY FROM ELEMENTS:    
    elms_dico = {}
    #node_elm_dico = {}
    node_lst = []
    #
    #print('_*_elm_lst',elm_lst)
    for elm in elm_lst:
        
        elm_tmp = []
        
        for i in range(1, len(elm)):
            #print('int(elm[i])',int(elm[i]),'\n')
            # print('1node_elm_dico',node_elm_dico,elm[0],elm[i],i,'\n')
            node_elm_dico[elm[i]].append(int(elm[0]))
            # print('2node_elm_dico',node_elm_dico,'\n')
            elm_tmp.append( int(elm[i]) )
        # print('1',elm_tmp)
        # for node in elm_tmp:
            # if type(node) == int:
                # node_elm_dico[node].append(int(elm[0]))
             
                
                
          
        elm_tmp=[tuple(elm_tmp)]
        #elm_tmp.append(elm[-1])
        elm_tmp.append(elm_type)
        # print('2',elm_tmp)
        
        elms_dico.update( { int(elm[0]) : elm_tmp} )
        #print(elms_dico)
        
    

    
    return(elms_dico, nodes_dico, node_elm_dico)




def InclSets_to_dicos(linewise_Sets):
    i=0
    elSets_dico = {}
    ################Examlpe:
    #       *Elset, elset=ElementSet1, generate
    #         1,  5,   1
    #       *Elset, elset=ElementSet2
    #         9,  12,  15,  16
    #elSets_dico:  {'ElementSet1': [1, 2, 3, 4, 5], 'ElementSet2': [9, 12, 15, 16]}
    
    nsets_dicos={}
    ################Examlpe:
    #       *Nset, nset=nset1, generate
    #         1,  5,   1
    #       *Nset, nset=nset2
    #         9,  12,  15,  16
    #nsets_dicos:  {'nset1': [1, 2, 3, 4, 5], 'nset2': [9, 12, 15, 16]}

    while i < (len(linewise_Sets)-1):
        #print(linewise_Sets)
        
        ElementNumbers=[]
        #Example:[1, 2, 3, 4, 5]
        
        NodeNumbers=[]
        #Example:[9, 12, 15, 16]
        
        #############################################################################
        ############Finding keywords '*Elset'
        #############################################################################
        if len(linewise_Sets[i][0]) > 0 and linewise_Sets[i][0].split()[0][0:6].lower()=='*elset':

            #finding Elset caption
            for FindElsetCaption in linewise_Sets[i][0].replace(' ','').split(','):
                if FindElsetCaption[0:6].lower()=='elset=':
                    ElsetCaption=FindElsetCaption[6:]
            
            #As shown in the example above, there are two methods Abaqus uses to store the element/node number of a Set. With or without 'generate' parameter.
            #This is checked and accordingly with the appropriate method the element/node number is stored.       
            if 'generate' in [j.strip().lower() for j in linewise_Sets[i][0].split(',')]:
                #Examlpe:
                #       *Elset, elset=ElementSet1, generate
                #         1,  5,   1
                
                i+=1
                while len(linewise_Sets[i][0]) > 1 and ((linewise_Sets[i][0].split())[0][0]) !=  '*' or (
                  len(linewise_Sets[i][0])) >= 2 and ((linewise_Sets[i][0].split())[0][1]) == '*':

                    if linewise_Sets[i][0].split(',')[0][0].strip() != '*':

                        firstElement=int(linewise_Sets[i][0].split(',')[0].strip())
                        increment=int(linewise_Sets[i][0].split(',')[2].strip())
                        LastElement=int(linewise_Sets[i][0].split(',')[1].strip())+increment
                        for x in range(firstElement, LastElement, increment):
                            
                            ElementNumbers.append(x)
                    i+=1
                elSets_dico.update( { ElsetCaption : ElementNumbers} )
                # print()
                # print('elSets_dico : ',elSets_dico)
                # print()

            elif 'generate' not in [j.strip().lower() for j in linewise_Sets[i][0].split(',')]:
                #Examlpe:
                #       *Elset, elset=ElementSet2
                #         1, 2, 3, 4, 5
                
                i+=1
                while len(linewise_Sets[i][0]) > 1 and ((linewise_Sets[i][0].split())[0][0]) !=  '*' or (
                  len(linewise_Sets[i][0])) >= 2 and ((linewise_Sets[i][0].split())[0][1]) == '*':
                  
                    if linewise_Sets[i][0].split(',')[0][0].strip() != '*':

                        for k in linewise_Sets[i][0].split(','):
                            #print('___***___',linewise_Sets[i][0].split(','))
                            if len(k.strip())>0:
                                ElementNumbers.append(int(k.strip()))
                    i+=1
                elSets_dico.update( { ElsetCaption : ElementNumbers} )
                # print()
                # print('elSets_dico: ',elSets_dico)
                # print()                        
        #############################################################################
        ############Finding keywords '*Nset'
        #############################################################################    
        elif len(linewise_Sets[i][0]) > 0 and linewise_Sets[i][0].split()[0][0:5].lower()=='*nset':
            
            #finding Nset caption
            for FindNsetCaption in linewise_Sets[i][0].replace(' ','').split(','):
                if FindNsetCaption[0:5].lower()=='nset=':
                    NsetCaption=FindNsetCaption[5:]

            #As shown in the example above, there are two methods Abaqus uses to store the element/node number of a Set. With or without 'generate' parameter.
            #This is checked and accordingly with the appropriate method the element/node number is stored. 
            if 'generate' in [j.strip().lower() for j in linewise_Sets[i][0].split(',')]:        
                #Examlpe:
                #       *Nset, nset=nset1, generate
                #         1,  5,   1   
   
                i+=1
                while len(linewise_Sets[i][0]) > 1 and ((linewise_Sets[i][0].split())[0][0]) !=  '*' or (
                  len(linewise_Sets[i][0])) >= 2 and ((linewise_Sets[i][0].split())[0][1]) == '*':

                    if linewise_Sets[i][0].split(',')[0][0].strip() != '*':

                        firstNode=int(linewise_Sets[i][0].split(',')[0].strip())
                        increment=int(linewise_Sets[i][0].split(',')[2].strip())
                        LastNode=int(linewise_Sets[i][0].split(',')[1].strip())+increment
                        for x in range(firstNode, LastNode, increment):
                            NodeNumbers.append(x)
                    i+=1
                nsets_dicos.update( { NsetCaption : NodeNumbers} )
                # print()
                # print('nsets_dicos: ',nsets_dicos)
                # print()
            elif 'generate' not in [j.strip().lower() for j in linewise_Sets[i][0].split(',')]:
                #Examlpe:
                #       *Nset, nset=nset2
                #         1, 2, 3, 4, 5

                i+=1
                while len(linewise_Sets[i][0]) > 1 and ((linewise_Sets[i][0].split())[0][0]) !=  '*' or (
                  len(linewise_Sets[i][0])) >= 2 and ((linewise_Sets[i][0].split())[0][1]) == '*':
                    
                    if linewise_Sets[i][0].split(',')[0][0].strip() != '*':
                        
                        for k in linewise_Sets[i][0].split(','):
                            try:
                                NodeNumbers.append(int(k.strip()))
                            except:
                                  print("line number {} in Nset&Elset include file ends with 'comma'.".format(i+1))
                            
                    i+=1
                nsets_dicos.update( { NsetCaption : NodeNumbers} )
                # print()
                # print('nsets_dicos: ',nsets_dicos)
                # print()

        else: #No Elset or Nset detected
            #print('final else')
            i+=1
    # print('elSets_dico: ',elSets_dico)
    # print('##############################')
    # print('nsets_dicos: ',nsets_dicos)
    return(elSets_dico, nsets_dicos)

##################################################################################
##################################################################################
##################################################################################
##################################################################################
##################################################################################
##################################################################################

def Elset_Material_Finder_INP_2D(linewise_inp_2D):
    i = 0
    HomogeneousElsets={}
    ################Examlpe: 
    #       *Shell Section, elset=ELEMENTSET, material=STEEL
    #HomogeneousElsets: {elset: material}
    #HomogeneousElsets: {'ELEMENTSET': 'STEEL'}
    CompositeElsets={}
    ################Examlpe:
    #       *Shell Section, elset=ElementSet, composite, orientation=Ori-2, layup=CompositeLayup-1
    #       0.1, 3, CarbonEpoxy, 0., CL1-Ply-1
    #       0.2, 3, CarbonEpoxy, 45., CL1-Ply-2
    #CompositeElsets: {Eleset:[[orientation,stack direction,layup,Offset ,Number of LAYUP Section points ],[Ply Relative Thickness, Number of PLY Section Points,Ply Material,PlyOrientationAngle,PlyName ],[ply 2]...[ply n]]}
    #CompositeElsets: {'ElementSet': [['Ori-2', 'CompositeLayup-1', 6], [0.1, 3, 'CarbonEpoxy', 0.0, 'CL1-Ply-1'], [0.2, 3, 'CarbonEpoxy', 45.0, 'CL1-Ply-2']
    #############
    while i < (len(linewise_inp_2D)-1):
        #print(linewise_inp_2D[i])
        if len(linewise_inp_2D[i][0]) > 0 and linewise_inp_2D[i][0].split(',')[0][0:14].lower()=='*shell section':
            
            
            for FindElsetCaption in linewise_inp_2D[i][0].split(','):
                
                if FindElsetCaption.strip()[0:6].lower()=='elset=':
                    ElsetCaption=FindElsetCaption.strip()[6:]
                    #print('ElsetCaption:',ElsetCaption)
                    break
                    
            #######################################################################
            ####  Abaqus Documentation:Abaqus>Keywords>S>*Shell SECTION:->      ###
            ####  The COMPOSITE and MATERIAL parameters are mutually exclusive. ###
            #######################################################################
            
            #***#
            # check if the founded Elsat is homogeneous
            #***#
            if [MaterialParameter for j in linewise_inp_2D[i][0].split(',') if (MaterialParameter := j.strip())[0:9].lower()=='material=']:

                Material=MaterialParameter[9:]
                #print('Material:', Material)
                HomogeneousElsets.update({ElsetCaption:Material})
                i += 1
            
            #***#
            # check if the founded Elsat is Composite
            #***#
            elif [CompositeParameter for j in linewise_inp_2D[i][0].split(',') if (CompositeParameter := j.strip().lower())=='composite']:
                
                CompositeElsets.update({ElsetCaption:[[]]})
                #locking for other information of layup: orientation=,layup=
                Layup_Caption = None
                LCS_orientation = None
                Layup_offset = 0
                for Parameter in linewise_inp_2D[i][0].split(','):
                
                    if (Parameter.strip().lower()=='*shell section' or Parameter.strip()[:6].lower()=='elset='
                          or Parameter.strip().lower()=='composite'):
                        continue
                        
                    elif Parameter.strip()[:12].lower()=='orientation=':#local coordinate system
                        LCS_orientation=Parameter.strip()[12:]
                        continue
                        
                    elif Parameter.strip()[:6].lower()=='layup=':#layup Caption
                        Layup_Caption=Parameter.strip()[6:]
                        continue

                    elif Parameter.strip()[:7].lower()=='offset=':#layup offset

                        Layup_offset = Parameter.strip()[7:].upper()
                        
                        if Layup_offset == "SNEG":
                            Layup_offset= "-0.5"
                            #print(str(Layup_offset+"−0.5"))
                        elif Layup_offset == "SPOS":
                            Layup_offset= "0.5" 
                            #print(str(Layup_offset+"+0.5"))
                        continue
                        
                    else :
                        print('\n*** WARNING! UNKNOWN PARAMETER FOR THIS SHELL SECTION!!!\n')
                        print('Shell Section line:',i)
                        print('parameter:',Parameter.strip())
                        break    

                CompositeElsets[ElsetCaption][0].append(LCS_orientation)
                CompositeElsets[ElsetCaption][0].append(Layup_Caption)
                #print(Layup_offset,"+0.5")
                CompositeElsets[ElsetCaption][0].append(Layup_offset)
                
                #going to the next line
                i += 1

               
                #writing down the Plies information one by one.
                #actual ply thickness,Ply Section Point Number,Ply Material,Ply Orientation Angle,Ply Name
                count=0
                while len(linewise_inp_2D[i][0]) > 1 and ((linewise_inp_2D[i][0].split())[0][0]) !=  '*' or (
                      len(linewise_inp_2D[i][0])) >= 2 and ((linewise_inp_2D[i][0].split())[0][1]) == '*':

                        if linewise_inp_2D[i][0].split(',')[0][0].strip() != '*':
                            
                            count += 1
                            CompositeElsets[ElsetCaption].append([])
                            ActualPlyThickness=float(linewise_inp_2D[i][0].split(',')[0].strip())
                            PlySectionPointNumber=int(linewise_inp_2D[i][0].split(',')[1].strip())
                            PlyMaterial=linewise_inp_2D[i][0].split(',')[2].strip()
                            
                            PlyOrientationAngle_0=  linewise_inp_2D[i][0].split(',')[3].strip().split('_')[1]
                            # print('*')
                            # print('PlyOrientationAngle_0',PlyOrientationAngle_0)
                            # print('PlyOrientationAngle_0[1:][:-3]',PlyOrientationAngle_0[1:][:-3])
                            # print('**')
                            if PlyOrientationAngle_0[0]   == '0':
                                PlyOrientationAngle =0.0
                            elif PlyOrientationAngle_0[0] == 'p':    
                                PlyOrientationAngle =float(PlyOrientationAngle_0[1:][:-3])*(+1.0)
                            elif PlyOrientationAngle_0[0] == 'm':    
                                PlyOrientationAngle =float(PlyOrientationAngle_0[1:][:-3])*(-1.0)   
                            PlyName=linewise_inp_2D[i][0].split(',')[4].strip()
                           
                            CompositeElsets[ElsetCaption][count].append(ActualPlyThickness)
                            CompositeElsets[ElsetCaption][count].append(PlySectionPointNumber)
                            CompositeElsets[ElsetCaption][count].append(PlyMaterial)
                            CompositeElsets[ElsetCaption][count].append(PlyOrientationAngle)
                            CompositeElsets[ElsetCaption][count].append(PlyName)
                            #######################Methode 2
                            # count += 1
                            # CompositeElsets[ElsetCaption].append([])
                            # for j in range(len(linewise_inp_2D[i][0].split(','))):
                            #     if j==0 or j==3 :
                            #         CompositeElsets[ElsetCaption][count].append(float(linewise_inp_2D[i][0].split(',')[j]))
                            #     elif j==1 :
                            #         CompositeElsets[ElsetCaption][count].append(int(linewise_inp_2D[i][0].split(',')[j]))    
                            #     else:
                            #         CompositeElsets[ElsetCaption][count].append(linewise_inp_2D[i][0].split(',')[j])
                            
                        #print('CompositeElsets in While:', CompositeElsets)
                        i += 1

            else:
                #if there are none of the two parameters(composite and material=...)
                print('\n*** ERROR! MATERIAL TYPE UNKNOWN!!!\n')
                return
            # Material=MaterialParameter.strip()[:]
            # print('Material:', Material)
            # HomogeneousElsets.update({ElsetCaption:Material})
            
        else:
        #In case the line is not the " *Shell section " command, just continue to check the next line.
            i += 1
    ##################********************************************##################
    #adding number of section points of each Elset to CompositeElsets dictionary
    for k in CompositeElsets.keys():
        NumberOfSectionPoint=0
        for i in range(1,len(CompositeElsets[k])):
            NumberOfSectionPoint=NumberOfSectionPoint+CompositeElsets[k][i][1]
        CompositeElsets[k][0].append(NumberOfSectionPoint)
    ##################********************************************##################
    # print('HomogeneousElsets:', HomogeneousElsets)
    # print('CompositeElsets:', CompositeElsets)
    return (HomogeneousElsets,CompositeElsets)

##################################################################################
##################################################################################
##################################################################################
##################################################################################
##################################################################################
##################################################################################

def ABQ_INP_TO_DICOS_3Dto2D_FinalVersion_2023_07_20_NVB01(work_dir=None, Setincl_path=None, MESHincl_path=None,
                                                          Source=None, Target=None):
    

 ##################################################################################
 ##
 ## USER INTERFACE:
 ##
 ##################################################################################
    #selecting Work Directory
    if not work_dir:
        msg = "Enter Work Directory"
        title = "Work Directory"
        default= "/media/marc/3bce7b8a-c915-44f3-8a5c-4971261f0262/COMMON_FILES/CEMSleeper/FEM/SINGLE-SLEEPER_2021-05-17/"
        # filetypes = ".control"
        work_dir = easygui.diropenbox(msg, title, default)
        work_dir =  work_dir + "/"
        os.chdir(work_dir)
        #print('WORK-DIRECTORY:')
        #print(work_dir)
        
        files = os.listdir(path=work_dir)
        

    #selecting abaqus input(*.inp) file of 3D-Analysis(source analysis)       
    if not Target:
        msg = str("Select the *.inp file")
        title = "ABQ-INP File Selection"
        default= work_dir + '*.inp'
        inp_path_source = easygui.fileopenbox(msg, title, default, filetypes='*.inp')
        
    
 ##################################################################################
 ##
 ## PREPARE INPUT:
 ##
 ##################################################################################
    
    
    #reading mesh include file using "read_inp_input()" function to create a linewise list(each line= a list with one string)
    linewise_incl = read_inp_input(inp_path_source)
    #creating "elms_dico", "nodes_dico" and "node_elm_dico" dictionary using "inp_to_dicos()" function
    elms_dico, nodes_dico, node_elm_dico = inp_to_dicos(linewise_incl)
    #***#
    
    #reading Sets include file using "read_inp_input()" function to create a linewise list(each line= a list with one string)
    linewise_Sets = read_inp_input(inp_path_source)
    #creating "elSets_dico" and "nsets_dicos" dictionary using "InclSets_to_dicos" function
    elSets_dico, nsets_dicos = InclSets_to_dicos(linewise_Sets)
    

    #reading input(*.inp) file using "read_inp_input()" function to create a linewise list(each line= a list with one string)
    linewise_inp_2D = read_inp_input(inp_path_source)
    #creating "Elset_Material_dicos" dictionary using "InclSets_to_dicos" function
    Elset_Material_dicos = Elset_Material_Finder_INP_2D(linewise_inp_2D)
    
    #***#
    
    #appending the elset that was defined for the material assignment. So the material for all elements can be easily found:
    #First, the elset containing the corresponding element is determined, and then it can be determined from elSets_dico which material each elset has.
    #"elms_dico" befor appending the "elset": elms_dico_old : {1: [(7, 8, 11, 10, 1, 2, 5, 4), 'ALL_ELMS', 'C3D8'], 2: [(8, 9, 12, 11, 2, 3, 6, 5), 'ALL_ELMS', 'C3D8'],...[]}
    for i in elms_dico:
        for elSetCaption, ElementsList in elSets_dico.items():
            for ElNumber in range(len(ElementsList)):
                if ElementsList[ElNumber] == i:
                    elms_dico[i].append(elSetCaption)
    #"elms_dico" after appending the "elset": elms_dico_new : {1: [(7, 8, 11, 10, 1, 2, 5, 4), 'ALL_ELMS', 'C3D8', ElementSet1], 2: [(8, 9, 12, 11, 2, 3, 6, 5), 'ALL_ELMS', 'C3D8', ElementSet5],...[]}              
                    
    #***#

    return elms_dico, nodes_dico, node_elm_dico, elSets_dico, nsets_dicos, Elset_Material_dicos
       


if __name__ == '__main__':    
    
    
    ABQ_INP_TO_DICOS_3Dto2D_FinalVersion_2023_07_20_NVB01()

